create or replace package body pkg_insert is


 -- 
 procedure frame_insert(frame_name in varchar2
                        ,frame_exec in integer
                        ,frame_parent in integer
                        ,frame_exempl in integer )
  is
  begin
    dbms_transaction.begin_discrete_transaction;

      insert into frame (fr_id,fr_name,fr_parent,fr_exempl_flag,fr_celev_flag,fr_execute_id)
      values (fr_seq.nextval,frame_name,frame_parent,frame_exempl,0,frame_exec);

    dbms_transaction.commit;
  end frame_insert;
  
 -- 
 procedure value_insert(value_name in varchar2)
  is
  begin
    dbms_transaction.begin_discrete_transaction;
      insert into attr_values (val_id,val_name)
      values (val_seq.nextval,value_name);
    dbms_transaction.commit;
  end value_insert;
  
 procedure slot_insert(slot_name in varchar2)
  is
  begin
    dbms_transaction.begin_discrete_transaction;
      insert into slots (sl_id,sl_name)
      values (slot_seq.nextval,slot_name);
    dbms_transaction.commit;
  end slot_insert;

procedure delete_values(del_value_id in attr_values.val_id%type)
 is
 begin
   dbms_transaction.begin_discrete_transaction; 
   delete from attr_values where val_id = del_value_id; 
   dbms_transaction.commit; 
 end;
 
 procedure delete_slots(del_value_id in integer)
 is
 begin
   dbms_transaction.begin_discrete_transaction; 
   delete from slots where sl_id = del_value_id; 
   dbms_transaction.commit; 
 end;
 
  
 procedure delete_frame(del_frame_id in frame.fr_id%type)
 is
 begin
   dbms_transaction.begin_discrete_transaction; 
   delete from frame where fr_id = del_frame_id; 
   dbms_transaction.commit; 
 end;
 
 procedure add_slot(frame_id in integer,
                    slot_id in integer,
                    value_id in integer)
 is
 begin
   dbms_transaction.begin_discrete_transaction;
      insert into a_s_v (id,sl_id,val_id,fr_id)
      values (asv_seq.nextval,slot_id,value_id,frame_id);
   dbms_transaction.commit;
 end add_slot;
 
 procedure delete_slot_value(del_id in integer)
 is
 begin
   dbms_transaction.begin_discrete_transaction; 
   delete from a_s_v where id = del_id; 
   dbms_transaction.commit;
 end;

 
end pkg_insert;
/

