create or replace package body pkg_select is

  procedure get_values(val_id in attr_values.val_id%type
                       ,val_curs out TCurs) is
    query_string varchar2(1000);
  begin
    query_string := 'select val_id
                           ,val_name
                    from attr_values';
    if val_id is not null then
    query_string := query_string 
                    || ' where val_id = ' 
                    || to_char(val_id);
    end if;
    open val_curs for query_string;
  end get_values;
  
  -- 
  procedure get_slots(slot_id in slots.sl_id%type
                       ,slot_curs out TCurs) is
    query_string varchar2(1000);
  begin
    query_string := 'select sl_id
                           ,sl_name
                    from slots';
    if slot_id is not null then
    query_string := query_string 
                    || ' where sl_id = ' 
                    || to_char(slot_id);
    end if;
    open slot_curs for query_string;
  end get_slots;
  
    
  -- 
  procedure get_frames(frame_id in frame.fr_id%type 
                       ,parent_id in frame.fr_id%type
                       ,exempl_flag in integer
                       ,frames_curs out TCurs) is
    query_string varchar2(1000);
  begin
    query_string := '
                select fr_c.fr_name 
                      ,fr_p.fr_name 
                      ,fr_c.fr_exempl_flag 
                      ,fr_c.fr_celev_flag 
                      ,fr_e.fr_name 
                      ,fr_c.fr_id        
                from frame fr_p
                     ,frame fr_c
                     ,frame fr_e
                where fr_p.fr_id(+) = fr_c.fr_parent
                      and fr_e.fr_id(+) = fr_c.fr_execute_id';
    if frame_id is not null then
      query_string := query_string 
                      || ' and fr_c.fr_id = '
                      || to_char(frame_id);                      
    end if;
    if parent_id is not null then
      query_string := query_string 
                      || ' and fr_p.fr_id = '
                      || to_char(parent_id);                      
    end if;
    if exempl_flag is not null then
      query_string := query_string
                      || ' and fr_c.fr_exempl_flag = '
                      || to_char(exempl_flag);      
    end if;
    
      query_string := query_string || ' order by 3,5';
    
    open frames_curs for query_string;
  end get_frames;
  
  procedure get_slots_vals(fr_id in integer
                           ,slot_curs out TCurs)
  is
    query_string varchar2(2000);
  begin
    query_string := '
                   select s.sl_name
       ,v.val_name
       ,a.id
from frame f
     ,attr_values v
     ,slots s
     ,a_s_v a
where  a.sl_id = s.sl_id
   and a.val_id = v.val_id
   and f.fr_id = a.fr_id
   and f.fr_id = ' || to_char(fr_id);
   
   open slot_curs for query_string;
  end;
  
  
  procedure get_query_slots(not_in_string in varchar2
                            ,parent integer
                            ,slots out TCurs)
  is
    query_string varchar2(1000);
  begin
    query_string := 'select f.fr_name
       ,s.sl_name
       ,v.val_name
       ,a.id
       ,v.val_id
       ,f.fr_id 
       ,f.fr_execute_id      
from frame f
     ,attr_values v
     ,slots s
     ,a_s_v a
     
where  a.sl_id = s.sl_id
   and a.val_id = v.val_id
   and f.fr_id = a.fr_id ';
   
   if parent is null then
     query_string := query_string || 'and f.fr_parent = (select fr_id from frame where fr_celev_flag = 1)';
   else 
     query_string := query_string 
                     || 'and f.fr_parent = '
                     || to_char(parent); 
   end if;
   
   if not_in_string is not null then
     query_string := query_string || not_in_string;
   end if;
   open slots for query_string;
  end;
    
end pkg_select;
/

